=head1 NAME

Tails::HasDBus::System - role providing a connection to the system DBus

=cut

package Tails::Role::HasDBus::System;

use 5.10.1;
use strict;
use warnings FATAL => 'all';
use autodie qw(:all);

use Carp::Assert::More;
use Function::Parameters;
use Net::DBus qw(:typing);
use Net::DBus::GLib;

use Moo::Role;
use MooX::late;
use namespace::clean;

has 'dbus'  => (
    isa        => 'Net::DBus',
    is         => 'ro',
    required   => 1,
    builder    => '_build_dbus',
);

method _build_dbus () {
    my $dbus = Net::DBus::GLib->system;
    assert_defined($dbus);
    return $dbus;
}

no Moo::Role;
1; # End of Tails::HasDBus::System
